# note this can only run on bearbin not snowbear due to path issues and 
# problem with ktinker package that pyplot needs

import numpy as np
import matplotlib.pyplot as plt
import sys
import numpy.linalg as la

startCh = int(sys.argv[1])
endCh = int(sys.argv[2])
nChannels = endCh-startCh+1
nLagsRead = int(sys.argv[3])
infileStart = sys.argv[4]
ninfiles = int(sys.argv[5])
infileEnd = sys.argv[6]
outfile = sys.argv[7]
nSamplesPerSec = 1000

# get first window cross correlation
xcorr = np.fromfile(infileStart+'1'+infileEnd,dtype='float64')
xcorr = np.reshape(xcorr,(nChannels,nLagsRead))
xcorr = xcorr/la.norm(xcorr,'fro')

for i in range(2,ninfiles+1):
    # add on rest of windows' cross correlations
    infile = infileStart+str(i)+infileEnd
    one_xcorr = np.fromfile(infile,dtype='float64')
    one_xcorr = np.reshape(one_xcorr,(nChannels,nLagsRead))
    print(one_xcorr)
    xcorr = xcorr + one_xcorr/la.norm(one_xcorr,'fro')
xcorr = xcorr/np.sqrt(float(ninfiles))

np.save(outfile,xcorr) # save stack

nLags = nLagsRead
# 1 min vmin = -200 vmax = 200
# 10 min -2000 to 2000
#plt.imshow(xcorr[:,:],aspect='auto',interpolation='nearest',vmin=-1500,vmax=1500)
plt.imshow(xcorr[:,:],aspect='auto', interpolation='nearest', cmap=plt.get_cmap('Greys'), vmin=-.03,vmax=.03)
plt.ylabel('channel')
plt.yticks(np.arange(0,nChannels,100),np.arange(startCh,endCh+1,100))
plt.xlabel('time lag')
plt.xticks(np.arange(0,nLags,nSamplesPerSec/2),np.arange(-nLags/(2*nSamplesPerSec),nLags/(2*nSamplesPerSec),1.0/2))
plt.title('stack of windowed cross-correlations')
plt.colorbar()
plt.show()
plt.clf()
