import numpy as np
import matplotlib
import matplotlib.pyplot as plt
import sys
import os
from string import *
import struct

infile = sys.argv[1]
startChannel = int(sys.argv[2])
nChannels = int(sys.argv[3])
specOutput = sys.argv[4] # file to write spectrum pdf
zoomSpecOutput = sys.argv[5] # file to write zoomed spectrum pdf
fileSize = os.path.getsize(infile)
nBytesPerDbl = 8
nFrq = fileSize/(nBytesPerDbl*nChannels)
maxFrq = 500 # should automate this later
nFrqPerBin = float(maxFrq)/float(nFrq)

spectrum = np.fromfile(infile,dtype='float64')
spectrum = np.reshape(spectrum,(nChannels,nFrq))
print(spectrum)

font = {'family' : 'sans-serif',
        'weight' : 'normal',
        'size' : 28}
matplotlib.rc('font',**font)

nTicks = 5
plt.imshow(spectrum[:,:int(maxFrq/nFrqPerBin)]/(2*10**7),aspect='auto',interpolation='nearest',vmax=1)
plt.xticks(np.arange(0,int(maxFrq/nFrqPerBin),int(maxFrq/(nFrqPerBin*nTicks))),np.arange(0,maxFrq,maxFrq/nTicks))
plt.xlabel('Hz')
plt.ylabel('channel (1 m per channel)')
plt.title('Spectral stack')
plt.colorbar()
plt.savefig(specOutput)
plt.clf()

zoomFrq = 30
plt.imshow(spectrum[:,:int(zoomFrq/nFrqPerBin)]/(2*10**7),aspect='auto',interpolation='nearest',vmax=1)
plt.xticks(np.arange(0,int(zoomFrq/nFrqPerBin),int(zoomFrq/(nFrqPerBin*nTicks))),np.arange(0,zoomFrq,zoomFrq/nTicks))
plt.xlabel('Hz')
plt.ylabel('channel (1 m per channel)')
plt.title('Zoomed spectral stack ')
plt.colorbar()
plt.savefig(zoomSpecOutput)
plt.clf()

#startNS = 500
#endNS = 1200
#plt.imshow((spectrum[startNS:endNS+1,:int(zoomFrq/nFrqPerBin)])*(spectrum[startNS:endNS+1,:int(zoomFrq/nFrqPerBin)]),aspect='auto',interpolation='nearest',vmin=0,vmax=8*10**14)
#nTicks = 4
##plt.title('Square spectral stack, Aug. 6, channels in/around N/S line')
#plt.xticks(np.arange(0,int(zoomFrq/nFrqPerBin),int(zoomFrq/(nFrqPerBin*nTicks))),np.ar#ange(0,zoomFrq,zoomFrq/nTicks))
#plt.yticks(np.arange(0,endNS-startNS+199,200),np.arange(startNS,endNS+199,200))
#plt.ylabel('channel number (1 m per channel)')
#plt.xlabel('Hz')
##plt.colorbar()
#plt.show()
##plt.savefig('output/spec_to_25Hz_NSLine_Aug6.pdf')
##plt.clf()





