# note this can only run on bearbin not snowbear due to path issues and 
# problem with ktinker package that pyplot needs

import numpy as np
import matplotlib.pyplot as plt
import sys
import numpy.linalg as la
import numpy.fft as ft

startCh = int(sys.argv[1])
endCh = int(sys.argv[2])
nChannels = endCh-startCh+1
nLagsRead = int(sys.argv[3])
outfile = sys.argv[4]
nSamplesPerSec = 1000

firstStackCh = 843
lastStackCh = 847
infilestart = 'output/xcoher_NS_ch'
infileEnd = '_all_subsets.bin.npy'
windowWidth = lastStackCh-firstStackCh
nChannelsSubset = nChannels-windowWidth
stackXCoher = np.zeros((nChannelsSubset,nLagsRead))
for ch in range(firstStackCh,lastStackCh+1):
    infile = infilestart+str(ch)+infileEnd
    thisxcoher = np.load(infile)
    thisxcoher = np.reshape(thisxcoher,(nChannels,nLagsRead))
    earlyOmission = lastStackCh-ch
    lateOmission = windowWidth-earlyOmission
    print(earlyOmission)
    print(lateOmission)
    print(thisxcoher[earlyOmission:nChannels-lateOmission,:].size)
    print(stackXCoher.size)
    stackXCoher = stackXCoher + thisxcoher[earlyOmission:nChannels-lateOmission,:]/(windowWidth+1)


# zero the infinite velocity events
fourier = ft.fft2(stackXCoher)
fourier[0,:] = fourier[0,:]*0.01
stackXCoher = np.real(ft.ifft2(fourier))

nLags = nLagsRead
# 1 min vmin = -200 vmax = 200
# 10 min -2000 to 2000
#plt.imshow(xcorr[:,:],aspect='auto',interpolation='nearest',vmin=-1500,vmax=1500)
plt.imshow(stackXCoher[:,:],aspect='auto', interpolation='nearest', cmap=plt.get_cmap('Greys'), vmin=-.02,vmax=.02)
plt.ylabel('channel')
plt.yticks(np.arange(0,nChannelsSubset,100),np.arange(startCh+windowWidth/2,endCh+1-windowWidth/2,100))
plt.xlabel('time lag')
plt.xticks(np.arange(0,nLags,nSamplesPerSec/2),np.arange(-nLags/(2*nSamplesPerSec),nLags/(2*nSamplesPerSec),1.0/2))
plt.title('stack of cross-coherence centered at Ch '+str((firstStackCh+lastStackCh)/2))
plt.colorbar()
plt.savefig(outfile)
#plt.show()
#plt.clf()
