import sys
import reading
import numpy as np
import matplotlib.pyplot as plt
import scipy.fftpack as ft


# read basic data about files
dataPath = sys.argv[1]
outfile = sys.argv[2]
verbose = True
intendian = '<'
infile1 = dataPath+'JBAF_FBX_150806190521.sgy'
nTraces,sampleFrq,nSamples,dataLen = reading.readSegY(infile1,intendian,verbose)
infile2 = dataPath+'JBAF_FBX_150806190621.sgy'
nTraces,sampleFrq,nSamples,dataLen = reading.readSegY(infile1,intendian,verbose)


# read traces from files
fltendian = '>'
traces = np.zeros((nTraces,nSamples*2))
for i in range(nTraces):
	print(i)
	traces[i,:nSamples] = reading.readTrace(infile1,nSamples,dataLen,1+i,fltendian)
for i in range(nTraces):
	print(i)
	traces[i,nSamples:] = reading.readTrace(infile2,nSamples,dataLen,1+i,fltendian)
	
# time series plot for all channels
plt.imshow(traces,aspect='auto',interpolation='nearest',vmin=-350,vmax=350,cmap=plt.get_cmap('bwr'))
plt.ylabel('channel')
plt.xlabel('time (1000 samples per second)')
secondsPerTick = 15
plt.xticks(np.arange(0,nSamples*2,sampleFrq*secondsPerTick),np.arange(0,nSamples*2,secondsPerTick*sampleFrq)/sampleFrq)
plt.colorbar()
plt.savefig(outfile)
