import sys
import datetime as dt

# two ways to run this code:
# 1. specify time of first and last record of interest, example:
# python writeFileNames.py startYr startMo startDay startHr startMin startSec endYr endMo endDay endHr endMin endSec secsBetweenFiles fileList startOfFileNames
# 2. specify time of first record and number of consecutive records of interest, example:
# python writeFileNames.py startYr startMo startDay startHr startMin startSec nRecords secsBetweenFiles fileList startOfFileNames


# start time info
startYr = int(sys.argv[1]) # four digit version of year e.g. 2015 
startMo = int(sys.argv[2])
startDay = int(sys.argv[3])
startHr = int(sys.argv[4])
startMin = int(sys.argv[5])
startSec = int(sys.argv[6])
startTime = dt.datetime(startYr,startMo,startDay,startHr,startMin,startSec)

if(len(sys.argv) > 12):
    currentSysArgvInd = 13
else:
    currentSysArgvInd = 8
#v seconds between record files
secsBetweenFiles = int(sys.argv[currentSysArgvInd])
timeBetweenFiles = dt.timedelta(seconds=secsBetweenFiles)

if(len(sys.argv) > 12):
    # end time info
    endYr = int(sys.argv[7])
    endMo = int(sys.argv[8])
    endDay = int(sys.argv[9])
    endHr = int(sys.argv[10])
    endMin = int(sys.argv[11])
    endSec = int(sys.argv[12])
    endTime = dt.datetime(endYr,endMo,endDay,endHr,endMin,endSec)
else:
    # end time info when number of files is specified
    nFilesToUse = int(sys.argv[7])
    timeChange = dt.timedelta(seconds=secsBetweenFiles*(nFilesToUse-1))
    endTime = timeChange + startTime
    


# open up file where you would write other file names
filelist = sys.argv[currentSysArgvInd+1]
myfile = open(filelist,'w')
startOfFileNames = sys.argv[currentSysArgvInd+2]

# define a function that turns an integer into a two digit string
def twoDigStr(someInt):
    twoDigs = 0
    if(someInt >= 100):
        twoDigs = int(someInt % 100)
    else:
        if(someInt >= 0):
            twoDigs = int(someInt)
        else:
            print("Error: twoDigStr can not be applied to negative number")
    if(twoDigs >=10):
        return str(twoDigs)
    else:
        return '0'+str(twoDigs)


# actually write the file names for these times
now = startTime
while(now <= endTime):
    fileName = startOfFileNames+twoDigStr(now.year)+twoDigStr(now.month)+twoDigStr(now.day)+twoDigStr(now.hour)+twoDigStr(now.minute)+twoDigStr(now.second)+'.sgy' # figure out the file name
    myfile.write(fileName+'\n') # write that time's filename into the file
    now = now + timeBetweenFiles # update to the next record time
myfile.close()


