# note this can only run on bearbin not snowbear due to path issues and 
# problem with ktinker package that pyplot needs

import numpy as np
import matplotlib.pyplot as plt
import sys
import numpy.linalg as la
import numpy.fft as ft

startCh = int(sys.argv[1])
endCh = int(sys.argv[2])
nChannels = endCh-startCh+1
nLagsRead = int(sys.argv[3])
infile = sys.argv[4]
outfile = sys.argv[5]
nSamplesPerSec = 1000

# get first window cross correlation
xcorr = np.load(infile)
print(xcorr.shape)
print(nLagsRead)
print(nChannels)
xcorr = np.reshape(xcorr,(nChannels,nLagsRead))

# zero the infinite velocity events
fourier = ft.fft2(xcorr)
fourier[0,:] = fourier[0,:]*0.01
xcorr = np.real(ft.ifft2(fourier))

nLags = nLagsRead
# 1 min vmin = -200 vmax = 200
# 10 min -2000 to 2000
#plt.imshow(xcorr[:,:],aspect='auto',interpolation='nearest',vmin=-1500,vmax=1500)
plt.imshow(xcorr[:,:],aspect='auto', interpolation='nearest', cmap=plt.get_cmap('Greys'), vmin=-.02,vmax=.02)
plt.ylabel('channel')
plt.yticks(np.arange(0,nChannels,100),np.arange(startCh,endCh+1,100))
plt.xlabel('time lag')
plt.xticks(np.arange(0,nLags,nSamplesPerSec/2),np.arange(-nLags/(2*nSamplesPerSec),nLags/(2*nSamplesPerSec),1.0/2))
plt.title('stack of cross-coherence')
plt.colorbar()
plt.savefig(outfile)
#plt.show()
#plt.clf()
